/// Marks a class that can be initialized.
abstract class Initializable {
  /// Called to initialize this object.
  ///
  /// Override this method to implement you custom initialization logic.
  ///
  /// An optional [parameter] is passed when initializing this object.
  void init([Map<String, Object> parameters]) {}
}
