import 'package:arch/src/service_locator.dart';
import 'package:get_it/get_it.dart';

class ServiceLocatorImpl implements ServiceLocator {
  static final i = GetIt.I;

  @override
  T resolve<T>([String name]) {
    try {
      if (name?.isNotEmpty ?? false == true) {
        return i.get<Object>(instanceName: name) as T;
      } else {
        return i.get<T>();
      }
    } catch (e) {
      throw Error.safeToString('Failed to resolve <$T>. Did you registered it?');
    }
  }

  @override
  bool canResolve<T>({Object instance, String name}) {
    try {
      return i.isRegistered<T>(instance: instance, instanceName: name);
    } catch (e) {
      return false;
    }
  }
}
