/// Locates services registered,
abstract class ServiceLocator {
  /// Resolves an instance of [T].
  ///
  /// - [name] - Used to determine what instance of [T] to resolve.
  T resolve<T>([String name]);

  /// Determines whether an instance of [T] can be resolved.
  ///
  /// - [instance] - Can be optionally passed to determine whether that object can be resolved.
  /// - [name] - Can be optionally passed to determine [T] with [name] can be resolved.
  bool canResolve<T>({Object instance, String name});
}
