import 'package:arch/src/dialog.dart';
import 'package:arch/src/initializable.dart';
import 'package:arch/src/listenable_model.dart';
import 'package:arch/src/navigation.dart';
import 'package:meta/meta.dart';

/// Base class for view models.
abstract class ViewModelBase extends ListenableModel implements Initializable {
  ViewModelBase({this.navigationService, this.dialogService});

  @protected
  final NavigationService navigationService;

  @protected
  final DialogService dialogService;

  @override
  void init([Map<String, Object> parameters]) {}
}

/// Base class for dialog models.
abstract class DialogModelBase extends ListenableModel implements Initializable {
  DialogModelBase(this._dialogService);

  final DialogService _dialogService;

  @override
  void init([Map<String, Object> parameters]) {}

  /// Closes the dialog this model is attached to.
  ///
  /// Returns an [optional] result.
  @nonVirtual
  void pop([Map<String, Object> result]) => _dialogService.pop(result);
}
